move "--follow needs one pathspec" rule to diff_setup_done
[git.git] / git-submodule.sh
blob66f5f752c5fb6745ab409199deb775c4704ab3e6
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 command=
26 branch=
27 force=
28 reference=
29 cached=
30 recursive=
31 init=
32 files=
33 remote=
34 nofetch=
35 update=
36 prefix=
37 custom_name=
38 depth=
40 # The function takes at most 2 arguments. The first argument is the
41 # URL that navigates to the submodule origin repo. When relative, this URL
42 # is relative to the superproject origin URL repo. The second up_path
43 # argument, if specified, is the relative path that navigates
44 # from the submodule working tree to the superproject working tree.
46 # The output of the function is the origin URL of the submodule.
48 # The output will either be an absolute URL or filesystem path (if the
49 # superproject origin URL is an absolute URL or filesystem path,
50 # respectively) or a relative file system path (if the superproject
51 # origin URL is a relative file system path).
53 # When the output is a relative file system path, the path is either
54 # relative to the submodule working tree, if up_path is specified, or to
55 # the superproject working tree otherwise.
56 resolve_relative_url ()
58 remote=$(get_default_remote)
59 remoteurl=$(git config "remote.$remote.url") ||
60 remoteurl=$(pwd) # the repository is its own authoritative upstream
61 url="$1"
62 remoteurl=${remoteurl%/}
63 sep=/
64 up_path="$2"
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
70 ./*|../*)
71 is_relative=t
74 is_relative=t
75 remoteurl="./$remoteurl"
77 esac
79 while test -n "$url"
81 case "$url" in
82 ../*)
83 url="${url#../}"
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
100 esac
102 ./*)
103 url="${url#./}"
106 break;;
107 esac
108 done
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
113 # Resolve a path to be relative to another path. This is intended for
114 # converting submodule paths when git-submodule is run in a subdirectory
115 # and only handles paths where the directory separator is '/'.
117 # The output is the first argument as a path relative to the second argument,
118 # which defaults to $wt_prefix if it is omitted.
119 relative_path ()
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
127 while test -n "$curdir"
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
134 esac
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
143 done
145 echo "$result$target"
149 # Get submodule info for registered submodules
150 # $@ = path to limit submodule list
152 module_list()
154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
156 git ls-files -z --error-unmatch --stage -- "$@" ||
157 echo "unmatched pathspec exists"
159 perl -e '
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
162 my @out = ();
163 my $unmatched = 0;
164 $/ = "\0";
165 while (<STDIN>) {
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
176 push @out, "$mode $null_sha1 U\t$path\n";
178 next;
180 push @out, "$_\n";
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
190 die_if_unmatched ()
192 if test "$1" = "#unmatched"
193 then
194 exit 1
199 # Print a submodule configuration setting
201 # $1 = submodule name
202 # $2 = option name
203 # $3 = default value
205 # Checks in the usual git-config places first (for overrides),
206 # otherwise it falls back on .gitmodules. This allows you to
207 # distribute project-wide defaults in .gitmodules, while still
208 # customizing individual repositories if necessary. If the option is
209 # not in .gitmodules either, print a default value.
211 get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
220 printf '%s' "${value:-$default}"
225 # Map submodule path to submodule name
227 # $1 = path
229 module_name()
231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
232 sm_path="$1"
233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
236 test -z "$name" &&
237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
238 echo "$name"
242 # Clone a submodule
244 # Prior to calling, cmd_update checks that a possibly existing
245 # path is not a git repository.
246 # Likewise, cmd_add checks that path does not exist at all,
247 # since it is the location of a new submodule.
249 module_clone()
251 sm_path=$1
252 name=$2
253 url=$3
254 reference="$4"
255 depth="$5"
256 quiet=
257 if test -n "$GIT_QUIET"
258 then
259 quiet=-q
262 gitdir=
263 gitdir_base=
264 base_name=$(dirname "$name")
266 gitdir=$(git rev-parse --git-dir)
267 gitdir_base="$gitdir/modules/$base_name"
268 gitdir="$gitdir/modules/$name"
270 if test -d "$gitdir"
271 then
272 mkdir -p "$sm_path"
273 rm -f "$gitdir/index"
274 else
275 mkdir -p "$gitdir_base"
277 clear_local_git_env
278 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
279 --separate-git-dir "$gitdir" "$url" "$sm_path"
280 ) ||
281 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
284 # We already are at the root of the work tree but cd_to_toplevel will
285 # resolve any symlinks that might be present in $PWD
286 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
287 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
288 # normalize Windows-style absolute paths to POSIX-style absolute paths
289 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
290 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
291 # Remove all common leading directories after a sanity check
292 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
293 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
295 while test "${a%%/*}" = "${b%%/*}"
297 a=${a#*/}
298 b=${b#*/}
299 done
300 # Now chop off the trailing '/'s that were added in the beginning
301 a=${a%/}
302 b=${b%/}
304 # Turn each leading "*/" component into "../"
305 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
306 echo "gitdir: $rel/$a" >"$sm_path/.git"
308 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
309 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
312 isnumber()
314 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
318 # Add a new submodule to the working tree, .gitmodules and the index
320 # $@ = repo path
322 # optional branch is stored in global branch variable
324 cmd_add()
326 # parse $args after "submodule ... add".
327 reference_path=
328 while test $# -ne 0
330 case "$1" in
331 -b | --branch)
332 case "$2" in '') usage ;; esac
333 branch=$2
334 shift
336 -f | --force)
337 force=$1
339 -q|--quiet)
340 GIT_QUIET=1
342 --reference)
343 case "$2" in '') usage ;; esac
344 reference_path=$2
345 shift
347 --reference=*)
348 reference_path="${1#--reference=}"
350 --name)
351 case "$2" in '') usage ;; esac
352 custom_name=$2
353 shift
355 --depth)
356 case "$2" in '') usage ;; esac
357 depth="--depth=$2"
358 shift
360 --depth=*)
361 depth=$1
364 shift
365 break
368 usage
371 break
373 esac
374 shift
375 done
377 if test -n "$reference_path"
378 then
379 is_absolute_path "$reference_path" ||
380 reference_path="$wt_prefix$reference_path"
382 reference="--reference=$reference_path"
385 repo=$1
386 sm_path=$2
388 if test -z "$sm_path"; then
389 sm_path=$(echo "$repo" |
390 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
393 if test -z "$repo" -o -z "$sm_path"; then
394 usage
397 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
399 # assure repo is absolute or relative to parent
400 case "$repo" in
401 ./*|../*)
402 test -z "$wt_prefix" ||
403 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
405 # dereference source url relative to parent's url
406 realrepo=$(resolve_relative_url "$repo") || exit
408 *:*|/*)
409 # absolute url
410 realrepo=$repo
413 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
415 esac
417 # normalize path:
418 # multiple //; leading ./; /./; /../; trailing /
419 sm_path=$(printf '%s/\n' "$sm_path" |
420 sed -e '
421 s|//*|/|g
422 s|^\(\./\)*||
423 s|/\./|/|g
424 :start
425 s|\([^/]*\)/\.\./||
426 tstart
427 s|/*$||
429 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
430 die "$(eval_gettext "'\$sm_path' already exists in the index")"
432 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
433 then
434 eval_gettextln "The following path is ignored by one of your .gitignore files:
435 \$sm_path
436 Use -f if you really want to add it." >&2
437 exit 1
440 if test -n "$custom_name"
441 then
442 sm_name="$custom_name"
443 else
444 sm_name="$sm_path"
447 # perhaps the path exists and is already a git repo, else clone it
448 if test -e "$sm_path"
449 then
450 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
451 then
452 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
453 else
454 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
457 else
458 if test -d ".git/modules/$sm_name"
459 then
460 if test -z "$force"
461 then
462 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
463 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
464 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
465 echo >&2 " $realrepo"
466 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
467 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
468 else
469 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
472 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
474 clear_local_git_env
475 cd "$sm_path" &&
476 # ash fails to wordsplit ${branch:+-b "$branch"...}
477 case "$branch" in
478 '') git checkout -f -q ;;
479 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
480 esac
481 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
483 git config submodule."$sm_name".url "$realrepo"
485 git add $force "$sm_path" ||
486 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
488 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
489 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
490 if test -n "$branch"
491 then
492 git config -f .gitmodules submodule."$sm_name".branch "$branch"
493 fi &&
494 git add --force .gitmodules ||
495 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
499 # Execute an arbitrary command sequence in each checked out
500 # submodule
502 # $@ = command to execute
504 cmd_foreach()
506 # parse $args after "submodule ... foreach".
507 while test $# -ne 0
509 case "$1" in
510 -q|--quiet)
511 GIT_QUIET=1
513 --recursive)
514 recursive=1
517 usage
520 break
522 esac
523 shift
524 done
526 toplevel=$(pwd)
528 # dup stdin so that it can be restored when running the external
529 # command in the subshell (and a recursive call to this function)
530 exec 3<&0
532 module_list |
533 while read mode sha1 stage sm_path
535 die_if_unmatched "$mode"
536 if test -e "$sm_path"/.git
537 then
538 displaypath=$(relative_path "$sm_path")
539 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
540 name=$(module_name "$sm_path")
542 prefix="$prefix$sm_path/"
543 clear_local_git_env
544 cd "$sm_path" &&
545 sm_path=$(relative_path "$sm_path") &&
546 # we make $path available to scripts ...
547 path=$sm_path &&
548 eval "$@" &&
549 if test -n "$recursive"
550 then
551 cmd_foreach "--recursive" "$@"
553 ) <&3 3<&- ||
554 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
556 done
560 # Register submodules in .git/config
562 # $@ = requested paths (default to all)
564 cmd_init()
566 # parse $args after "submodule ... init".
567 while test $# -ne 0
569 case "$1" in
570 -q|--quiet)
571 GIT_QUIET=1
574 shift
575 break
578 usage
581 break
583 esac
584 shift
585 done
587 module_list "$@" |
588 while read mode sha1 stage sm_path
590 die_if_unmatched "$mode"
591 name=$(module_name "$sm_path") || exit
593 displaypath=$(relative_path "$sm_path")
595 # Copy url setting when it is not set yet
596 if test -z "$(git config "submodule.$name.url")"
597 then
598 url=$(git config -f .gitmodules submodule."$name".url)
599 test -z "$url" &&
600 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
602 # Possibly a url relative to parent
603 case "$url" in
604 ./*|../*)
605 url=$(resolve_relative_url "$url") || exit
607 esac
608 git config submodule."$name".url "$url" ||
609 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
611 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
614 # Copy "update" setting when it is not set yet
615 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
616 test -n "$upd" &&
617 test -z "$(git config submodule."$name".update)"
618 then
619 case "$upd" in
620 rebase | merge | none)
621 ;; # known modes of updating
623 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
624 upd=none
626 esac
627 git config submodule."$name".update "$upd" ||
628 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
630 done
634 # Unregister submodules from .git/config and remove their work tree
636 # $@ = requested paths (use '.' to deinit all submodules)
638 cmd_deinit()
640 # parse $args after "submodule ... deinit".
641 while test $# -ne 0
643 case "$1" in
644 -f|--force)
645 force=$1
647 -q|--quiet)
648 GIT_QUIET=1
651 shift
652 break
655 usage
658 break
660 esac
661 shift
662 done
664 if test $# = 0
665 then
666 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
669 module_list "$@" |
670 while read mode sha1 stage sm_path
672 die_if_unmatched "$mode"
673 name=$(module_name "$sm_path") || exit
675 displaypath=$(relative_path "$sm_path")
677 # Remove the submodule work tree (unless the user already did it)
678 if test -d "$sm_path"
679 then
680 # Protect submodules containing a .git directory
681 if test -d "$sm_path/.git"
682 then
683 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
684 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
687 if test -z "$force"
688 then
689 git rm -qn "$sm_path" ||
690 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
692 rm -rf "$sm_path" &&
693 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
694 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
697 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
699 # Remove the .git/config entries (unless the user already did it)
700 if test -n "$(git config --get-regexp submodule."$name\.")"
701 then
702 # Remove the whole section so we have a clean state when
703 # the user later decides to init this submodule again
704 url=$(git config submodule."$name".url)
705 git config --remove-section submodule."$name" 2>/dev/null &&
706 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
708 done
712 # Update each submodule path to correct revision, using clone and checkout as needed
714 # $@ = requested paths (default to all)
716 cmd_update()
718 # parse $args after "submodule ... update".
719 orig_flags=
720 while test $# -ne 0
722 case "$1" in
723 -q|--quiet)
724 GIT_QUIET=1
726 -i|--init)
727 init=1
729 --remote)
730 remote=1
732 -N|--no-fetch)
733 nofetch=1
735 -f|--force)
736 force=$1
738 -r|--rebase)
739 update="rebase"
741 --reference)
742 case "$2" in '') usage ;; esac
743 reference="--reference=$2"
744 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
745 shift
747 --reference=*)
748 reference="$1"
750 -m|--merge)
751 update="merge"
753 --recursive)
754 recursive=1
756 --checkout)
757 update="checkout"
759 --depth)
760 case "$2" in '') usage ;; esac
761 depth="--depth=$2"
762 shift
764 --depth=*)
765 depth=$1
768 shift
769 break
772 usage
775 break
777 esac
778 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
779 shift
780 done
782 if test -n "$init"
783 then
784 cmd_init "--" "$@" || return
787 cloned_modules=
788 module_list "$@" | {
789 err=
790 while read mode sha1 stage sm_path
792 die_if_unmatched "$mode"
793 if test "$stage" = U
794 then
795 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
796 continue
798 name=$(module_name "$sm_path") || exit
799 url=$(git config submodule."$name".url)
800 branch=$(get_submodule_config "$name" branch master)
801 if ! test -z "$update"
802 then
803 update_module=$update
804 else
805 update_module=$(git config submodule."$name".update)
808 displaypath=$(relative_path "$prefix$sm_path")
810 if test "$update_module" = "none"
811 then
812 echo "Skipping submodule '$displaypath'"
813 continue
816 if test -z "$url"
817 then
818 # Only mention uninitialized submodules when its
819 # path have been specified
820 test "$#" != "0" &&
821 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
822 Maybe you want to use 'update --init'?")"
823 continue
826 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
827 then
828 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
829 cloned_modules="$cloned_modules;$name"
830 subsha1=
831 else
832 subsha1=$(clear_local_git_env; cd "$sm_path" &&
833 git rev-parse --verify HEAD) ||
834 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
837 if test -n "$remote"
838 then
839 if test -z "$nofetch"
840 then
841 # Fetch remote before determining tracking $sha1
842 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
843 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
845 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
846 sha1=$(clear_local_git_env; cd "$sm_path" &&
847 git rev-parse --verify "${remote_name}/${branch}") ||
848 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
851 if test "$subsha1" != "$sha1" -o -n "$force"
852 then
853 subforce=$force
854 # If we don't already have a -f flag and the submodule has never been checked out
855 if test -z "$subsha1" -a -z "$force"
856 then
857 subforce="-f"
860 if test -z "$nofetch"
861 then
862 # Run fetch only if $sha1 isn't present or it
863 # is not reachable from a ref.
864 (clear_local_git_env; cd "$sm_path" &&
865 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
866 test -z "$rev") || git-fetch)) ||
867 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
870 # Is this something we just cloned?
871 case ";$cloned_modules;" in
872 *";$name;"*)
873 # then there is no local change to integrate
874 update_module= ;;
875 esac
877 must_die_on_failure=
878 case "$update_module" in
879 rebase)
880 command="git rebase"
881 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
882 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
883 must_die_on_failure=yes
885 merge)
886 command="git merge"
887 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
888 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
889 must_die_on_failure=yes
892 command="${update_module#!}"
893 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
894 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
895 must_die_on_failure=yes
898 command="git checkout $subforce -q"
899 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
900 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
902 esac
904 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
905 then
906 say "$say_msg"
907 elif test -n "$must_die_on_failure"
908 then
909 die_with_status 2 "$die_msg"
910 else
911 err="${err};$die_msg"
912 continue
916 if test -n "$recursive"
917 then
919 prefix="$prefix$sm_path/"
920 clear_local_git_env
921 cd "$sm_path" &&
922 eval cmd_update "$orig_flags"
924 res=$?
925 if test $res -gt 0
926 then
927 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
928 if test $res -eq 1
929 then
930 err="${err};$die_msg"
931 continue
932 else
933 die_with_status $res "$die_msg"
937 done
939 if test -n "$err"
940 then
941 OIFS=$IFS
942 IFS=';'
943 for e in $err
945 if test -n "$e"
946 then
947 echo >&2 "$e"
949 done
950 IFS=$OIFS
951 exit 1
956 set_name_rev () {
957 revname=$( (
958 clear_local_git_env
959 cd "$1" && {
960 git describe "$2" 2>/dev/null ||
961 git describe --tags "$2" 2>/dev/null ||
962 git describe --contains "$2" 2>/dev/null ||
963 git describe --all --always "$2"
966 test -z "$revname" || revname=" ($revname)"
969 # Show commit summary for submodules in index or working tree
971 # If '--cached' is given, show summary between index and given commit,
972 # or between working tree and given commit
974 # $@ = [commit (default 'HEAD'),] requested paths (default all)
976 cmd_summary() {
977 summary_limit=-1
978 for_status=
979 diff_cmd=diff-index
981 # parse $args after "submodule ... summary".
982 while test $# -ne 0
984 case "$1" in
985 --cached)
986 cached="$1"
988 --files)
989 files="$1"
991 --for-status)
992 for_status="$1"
994 -n|--summary-limit)
995 summary_limit="$2"
996 isnumber "$summary_limit" || usage
997 shift
999 --summary-limit=*)
1000 summary_limit="${1#--summary-limit=}"
1001 isnumber "$summary_limit" || usage
1004 shift
1005 break
1008 usage
1011 break
1013 esac
1014 shift
1015 done
1017 test $summary_limit = 0 && return
1019 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1020 then
1021 head=$rev
1022 test $# = 0 || shift
1023 elif test -z "$1" -o "$1" = "HEAD"
1024 then
1025 # before the first commit: compare with an empty tree
1026 head=$(git hash-object -w -t tree --stdin </dev/null)
1027 test -z "$1" || shift
1028 else
1029 head="HEAD"
1032 if [ -n "$files" ]
1033 then
1034 test -n "$cached" &&
1035 die "$(gettext "The --cached option cannot be used with the --files option")"
1036 diff_cmd=diff-files
1037 head=
1040 cd_to_toplevel
1041 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1042 # Get modified modules cared by user
1043 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1044 sane_egrep '^:([0-7]* )?160000' |
1045 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1047 # Always show modules deleted or type-changed (blob<->module)
1048 test $status = D -o $status = T && echo "$sm_path" && continue
1049 # Respect the ignore setting for --for-status.
1050 if test -n "$for_status"
1051 then
1052 name=$(module_name "$sm_path")
1053 ignore_config=$(get_submodule_config "$name" ignore none)
1054 test $status != A -a $ignore_config = all && continue
1056 # Also show added or modified modules which are checked out
1057 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1058 echo "$sm_path"
1059 done
1062 test -z "$modules" && return
1064 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1065 sane_egrep '^:([0-7]* )?160000' |
1066 cut -c2- |
1067 while read mod_src mod_dst sha1_src sha1_dst status name
1069 if test -z "$cached" &&
1070 test $sha1_dst = 0000000000000000000000000000000000000000
1071 then
1072 case "$mod_dst" in
1073 160000)
1074 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1076 100644 | 100755 | 120000)
1077 sha1_dst=$(git hash-object $name)
1079 000000)
1080 ;; # removed
1082 # unexpected type
1083 eval_gettextln "unexpected mode \$mod_dst" >&2
1084 continue ;;
1085 esac
1087 missing_src=
1088 missing_dst=
1090 test $mod_src = 160000 &&
1091 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1092 missing_src=t
1094 test $mod_dst = 160000 &&
1095 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1096 missing_dst=t
1098 display_name=$(relative_path "$name")
1100 total_commits=
1101 case "$missing_src,$missing_dst" in
1103 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1106 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1108 t,t)
1109 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1112 errmsg=
1113 total_commits=$(
1114 if test $mod_src = 160000 -a $mod_dst = 160000
1115 then
1116 range="$sha1_src...$sha1_dst"
1117 elif test $mod_src = 160000
1118 then
1119 range=$sha1_src
1120 else
1121 range=$sha1_dst
1123 GIT_DIR="$name/.git" \
1124 git rev-list --first-parent $range -- | wc -l
1126 total_commits=" ($(($total_commits + 0)))"
1128 esac
1130 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1131 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1132 if test $status = T
1133 then
1134 blob="$(gettext "blob")"
1135 submodule="$(gettext "submodule")"
1136 if test $mod_dst = 160000
1137 then
1138 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1139 else
1140 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1142 else
1143 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1145 if test -n "$errmsg"
1146 then
1147 # Don't give error msg for modification whose dst is not submodule
1148 # i.e. deleted or changed to blob
1149 test $mod_dst = 160000 && echo "$errmsg"
1150 else
1151 if test $mod_src = 160000 -a $mod_dst = 160000
1152 then
1153 limit=
1154 test $summary_limit -gt 0 && limit="-$summary_limit"
1155 GIT_DIR="$name/.git" \
1156 git log $limit --pretty='format: %m %s' \
1157 --first-parent $sha1_src...$sha1_dst
1158 elif test $mod_dst = 160000
1159 then
1160 GIT_DIR="$name/.git" \
1161 git log --pretty='format: > %s' -1 $sha1_dst
1162 else
1163 GIT_DIR="$name/.git" \
1164 git log --pretty='format: < %s' -1 $sha1_src
1166 echo
1168 echo
1169 done
1172 # List all submodules, prefixed with:
1173 # - submodule not initialized
1174 # + different revision checked out
1176 # If --cached was specified the revision in the index will be printed
1177 # instead of the currently checked out revision.
1179 # $@ = requested paths (default to all)
1181 cmd_status()
1183 # parse $args after "submodule ... status".
1184 while test $# -ne 0
1186 case "$1" in
1187 -q|--quiet)
1188 GIT_QUIET=1
1190 --cached)
1191 cached=1
1193 --recursive)
1194 recursive=1
1197 shift
1198 break
1201 usage
1204 break
1206 esac
1207 shift
1208 done
1210 module_list "$@" |
1211 while read mode sha1 stage sm_path
1213 die_if_unmatched "$mode"
1214 name=$(module_name "$sm_path") || exit
1215 url=$(git config submodule."$name".url)
1216 displaypath=$(relative_path "$prefix$sm_path")
1217 if test "$stage" = U
1218 then
1219 say "U$sha1 $displaypath"
1220 continue
1222 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1223 then
1224 say "-$sha1 $displaypath"
1225 continue;
1227 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1228 then
1229 set_name_rev "$sm_path" "$sha1"
1230 say " $sha1 $displaypath$revname"
1231 else
1232 if test -z "$cached"
1233 then
1234 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1236 set_name_rev "$sm_path" "$sha1"
1237 say "+$sha1 $displaypath$revname"
1240 if test -n "$recursive"
1241 then
1243 prefix="$displaypath/"
1244 clear_local_git_env
1245 cd "$sm_path" &&
1246 eval cmd_status
1247 ) ||
1248 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1250 done
1253 # Sync remote urls for submodules
1254 # This makes the value for remote.$remote.url match the value
1255 # specified in .gitmodules.
1257 cmd_sync()
1259 while test $# -ne 0
1261 case "$1" in
1262 -q|--quiet)
1263 GIT_QUIET=1
1264 shift
1266 --recursive)
1267 recursive=1
1268 shift
1271 shift
1272 break
1275 usage
1278 break
1280 esac
1281 done
1282 cd_to_toplevel
1283 module_list "$@" |
1284 while read mode sha1 stage sm_path
1286 die_if_unmatched "$mode"
1287 name=$(module_name "$sm_path")
1288 url=$(git config -f .gitmodules --get submodule."$name".url)
1290 # Possibly a url relative to parent
1291 case "$url" in
1292 ./*|../*)
1293 # rewrite foo/bar as ../.. to find path from
1294 # submodule work tree to superproject work tree
1295 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1296 # guarantee a trailing /
1297 up_path=${up_path%/}/ &&
1298 # path from submodule work tree to submodule origin repo
1299 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1300 # path from superproject work tree to submodule origin repo
1301 super_config_url=$(resolve_relative_url "$url") || exit
1304 sub_origin_url="$url"
1305 super_config_url="$url"
1307 esac
1309 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1310 then
1311 displaypath=$(relative_path "$prefix$sm_path")
1312 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1313 git config submodule."$name".url "$super_config_url"
1315 if test -e "$sm_path"/.git
1316 then
1318 clear_local_git_env
1319 cd "$sm_path"
1320 remote=$(get_default_remote)
1321 git config remote."$remote".url "$sub_origin_url"
1323 if test -n "$recursive"
1324 then
1325 prefix="$prefix$sm_path/"
1326 eval cmd_sync
1331 done
1334 # This loop parses the command line arguments to find the
1335 # subcommand name to dispatch. Parsing of the subcommand specific
1336 # options are primarily done by the subcommand implementations.
1337 # Subcommand specific options such as --branch and --cached are
1338 # parsed here as well, for backward compatibility.
1340 while test $# != 0 && test -z "$command"
1342 case "$1" in
1343 add | foreach | init | deinit | update | status | summary | sync)
1344 command=$1
1346 -q|--quiet)
1347 GIT_QUIET=1
1349 -b|--branch)
1350 case "$2" in
1352 usage
1354 esac
1355 branch="$2"; shift
1357 --cached)
1358 cached="$1"
1361 break
1364 usage
1367 break
1369 esac
1370 shift
1371 done
1373 # No command word defaults to "status"
1374 if test -z "$command"
1375 then
1376 if test $# = 0
1377 then
1378 command=status
1379 else
1380 usage
1384 # "-b branch" is accepted only by "add"
1385 if test -n "$branch" && test "$command" != add
1386 then
1387 usage
1390 # "--cached" is accepted only by "status" and "summary"
1391 if test -n "$cached" && test "$command" != status -a "$command" != summary
1392 then
1393 usage
1396 "cmd_$command" "$@"